factory.h File Reference
Include dependency graph for factory.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | pw_factory_events
| Factory events, listen to them with pw_factory_add_listener. More...
struct | pw_factory_implementation

## Macros

#define | PW_TYPE_INTERFACE__Factory PW_TYPE_INTERFACE_BASE "Factory"
#define | PW_TYPE_FACTORY_BASE PW_TYPE_INTERFACE__Factory ":"
#define | PW_VERSION_FACRORY_EVENTS 0
#define | PW_VERSION_FACTORY_IMPLEMENTATION 0

## Functions

struct pw_factory * | pw_factory_new (struct pw_core *core, const char *name, uint32_t type, uint32_t version, struct pw_properties *properties, size_t user_data_size)
int | pw_factory_register (struct pw_factory *factory, struct pw_client *owner, struct pw_global *parent, struct pw_properties *properties)
void | pw_factory_destroy (struct pw_factory *factory)
void * | pw_factory_get_user_data (struct pw_factory *factory)
struct pw_global * | pw_factory_get_global (struct pw_factory *factory)
| Get the global of this factory. More...
void | pw_factory_add_listener (struct pw_factory *factory, struct spa_hook *listener, const struct pw_factory_events *events, void *data)
| Add an event listener. More...
void | pw_factory_set_implementation (struct pw_factory *factory, const struct pw_factory_implementation *implementation, void *data)
void * | pw_factory_create_object (struct pw_factory *factory, struct pw_resource *resource, uint32_t type, uint32_t version, struct pw_properties *properties, uint32_t new_id)

## Macro Definition Documentation

## PW_TYPE_FACTORY_BASE

#define PW_TYPE_FACTORY_BASE PW_TYPE_INTERFACE__Factory ":"

## PW_TYPE_INTERFACE__Factory

#define PW_TYPE_INTERFACE__Factory PW_TYPE_INTERFACE_BASE "Factory"

Referenced by pw_type::pw_type_init().

## PW_VERSION_FACRORY_EVENTS

#define PW_VERSION_FACRORY_EVENTS 0

## PW_VERSION_FACTORY_IMPLEMENTATION

#define PW_VERSION_FACTORY_IMPLEMENTATION 0

## Function Documentation

## pw_factory_add_listener()

void pw_factory_add_listener | ( | struct pw_factory * | factory,
|  | struct spa_hook * | listener,
|  | const struct pw_factory_events * | events,
|  | void * | data
| ) |  |

Add an event listener.

## pw_factory_create_object()

void* pw_factory_create_object | ( | struct pw_factory * | factory,
|  | struct pw_resource * | resource,
|  | uint32_t | type,
|  | uint32_t | version,
|  | struct pw_properties * | properties,
|  | uint32_t | new_id
| ) |  |

## pw_factory_destroy()

void pw_factory_destroy | ( | struct pw_factory * | factory | ) |

References pw_global_destroy(), pw_properties_free(), and pw_resource_destroy().

## pw_factory_get_global()

struct pw_global* pw_factory_get_global | ( | struct pw_factory * | factory | ) |

Get the global of this factory.

## pw_factory_get_user_data()

void* pw_factory_get_user_data | ( | struct pw_factory * | factory | ) |

## pw_factory_new()

struct pw_factory* pw_factory_new | ( | struct pw_core * | core,
|  | const char * | name,
|  | uint32_t | type,
|  | uint32_t | version,
|  | struct pw_properties * | properties,
|  | size_t | user_data_size
| ) |  |

References pw_properties::dict.

## pw_factory_register()

int pw_factory_register | ( | struct pw_factory * | factory,
|  | struct pw_client * | owner,
|  | struct pw_global * | parent,
|  | struct pw_properties * | properties
| ) |  |

References pw_global_add_listener(), pw_global_new(), pw_global_register(), pw_properties_new(), pw_properties_set(), pw_properties_setf(), and PW_VERSION_FACTORY.

## pw_factory_set_implementation()

void pw_factory_set_implementation | ( | struct pw_factory * | factory,
|  | const struct pw_factory_implementation * | implementation,
|  | void * | data
| ) |  |